# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Functions

* [`consul_data::get_key`](#consul_dataget_key): Get the value of a key from Consul
* [`consul_data::get_service_nodes`](#consul_dataget_service_nodes): Querys for nodes providing a given service
* [`consul_data::set_key`](#consul_dataset_key): Set, update, or delete a key in Consul

## Functions

### <a name="consul_dataget_key"></a>`consul_data::get_key`

Type: Ruby 4.x API

Get the value of a key from Consul

#### `consul_data::get_key(String[1] $consul_url, String[1] $key, Optional[Enum[hash, json, json_pretty, string]] $key_return_format)`

Get the value of a key from Consul

Returns: `Any` the value of the key in the specified format

##### `consul_url`

Data type: `String[1]`

The full url including port for querying Consul

##### `key`

Data type: `String[1]`

The key you wish to query for

##### `key_return_format`

Data type: `Optional[Enum[hash, json, json_pretty, string]]`

The format in which to return the value of the key key.
Defaults to 'string' but may also be 'hash', json', or 'json_pretty'.
All options other than 'string' assume the data is stored in JSON format.

### <a name="consul_dataget_service_nodes"></a>`consul_data::get_service_nodes`

Type: Ruby 4.x API

Querys for nodes providing a given service

#### `consul_data::get_service_nodes(String[1] $consul_url, String[1] $service)`

Querys for nodes providing a given service

Returns: `Any` A hash representing the JSON response from Consul

##### `consul_url`

Data type: `String[1]`

The full url including port for querying Consul

##### `service`

Data type: `String[1]`

The service you want to get a list of nodes for

### <a name="consul_dataset_key"></a>`consul_data::set_key`

Type: Ruby 4.x API

Set, update, or delete a key in Consul

#### `consul_data::set_key(String[1] $consul_url, String[1] $key, Undef $value)`

Delete a key in Consul

Returns: `Any` Nothing is returned from this function

##### `consul_url`

Data type: `String[1]`

The full url including port for querying Consul

##### `key`

Data type: `String[1]`

The key you wish to delete

##### `value`

Data type: `Undef`

`undef` is the only valid value here

#### `consul_data::set_key(String[1] $consul_url, String[1] $key, String[1] $value)`

Update a key to a string value in Consul

Returns: `Any` Nothing is returned from this function

##### `consul_url`

Data type: `String[1]`

The full url including port for querying Consul

##### `key`

Data type: `String[1]`

The key you wish to update

##### `value`

Data type: `String[1]`

The string that you wish to have set as the value for the key

#### `consul_data::set_key(String[1] $consul_url, String[1] $key, Variant[Hash, Array[Hash]] $value)`

Update a key to a json value in Consul

Returns: `Any` Nothing is returned from this function

##### `consul_url`

Data type: `String[1]`

The full url including port for querying Consul

##### `key`

Data type: `String[1]`

The key you wish to update

##### `value`

Data type: `Variant[Hash, Array[Hash]]`

The array or hash that you wish to be stored in Consul as JSON

